<template>
  <main>
    <AddressItem
      :address="from"
      name="from"
      @update="addressToEdit = 'from'"
      @search="searchAddress(from)"
    />
    <AddressItem
      :address="to"
      name="to"
      @update="addressToEdit = 'to'"
      @search="searchAddress(to)"
    />

    <!-- <AddressForm v-model="this[addressToEdit]" v-if="addressToEdit" /> -->
    <AddressForm v-model="from" v-if="addressToEdit === 'from'" />
    <AddressForm v-model="to" v-if="addressToEdit === 'to'" />

    <AddressResult :results="searchResults" />
  </main>
</template>

<script>
import AddressItem from "@/components/AddressItem.vue";
import AddressForm from "@/components/AddressForm.vue";
import AddressResult from "@/components/AddressResult.vue";

export default {
  components: {
    AddressItem,
    AddressForm,
    AddressResult,
  },
  props: {
    address: String,
  },
  data() {
    return {
      addressToEdit: null,
      from: {
        road: "3 Villeneuve",
        zipCode: "44130",
        city: "Notre dame des Landes",
        complement: "ZAD",
        country: "Loire Atlantique",
      },
      to: {
        road: "rue riquet",
        zipCode: "31000",
        city: "Toulouse",
        state: "France",
      },
      searchResults: [],
    };
  },
  methods: {
    async searchAddress(address) {
      const API = "https://api-adresse.data.gouv.fr/search/?q=";
      try {
        const res = await fetch(API + address.city);
        const data = await res.json();
        this.searchResults = data.features;
      } catch (error) {
        console.error(error);
      }
    },
  },
  created() {
    if (!this.address) return;
    try {
      this.searchAddress(JSON.parse(this.address));
    } catch (error) {
      console.error(error);
    }
  },
};
</script>
